package com.zoniot.ccrc.commom.exception;


import com.zoniot.ccrc.commom.model.ResultStatus;

/**
 * 应用异常
 *
 * @author lin
 */
public class ApplicationException extends RuntimeException {

    private static final long serialVersionUID = -2678203134198782909L;

    public static final String MESSAGE = "应用异常";

    protected int status = ResultStatus.APPLICATION_ERROR.getStatus();

    public ApplicationException() {
        super(MESSAGE);
    }

    public ApplicationException(String message) {
        super(message);
    }

    public ApplicationException(int status, String message) {
        super(message);
        this.status = status;
    }

    public ApplicationException(String message, Throwable cause) {
        super(message, cause);
    }

    public ApplicationException(int status, String message, Throwable cause) {
        super(message, cause);
        this.status = status;
    }

    public ApplicationException(Throwable cause) {
        super(cause);
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }
}
