package com.zoniot.ccrc.controller.applets;

import com.zoniot.ccrc.commom.model.AjaxMessage;
import com.zoniot.ccrc.commom.model.Pagination;
import com.zoniot.ccrc.commom.model.ResultStatus;
import com.zoniot.ccrc.dto.ClientUserDto;
import com.zoniot.ccrc.entity.ClientUser;
import com.zoniot.ccrc.service.AppletsService;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.math.BigInteger;

@Controller
@RequestMapping("appletUser")
public class AppletsUserController {
    @Autowired
    private AppletsService appletsService;
    @ResponseBody
    @GetMapping("/getAccountInfo")
    @ApiOperation(value = "获取默认客户信息实时数据(计费系统)")
    public AjaxMessage<ClientUserDto> getDeviceInfoReal(

    ) {
        ClientUserDto accountInfoDto = appletsService.findUserAmountByIdReal();

        return new AjaxMessage<>(ResultStatus.OK, accountInfoDto);
    }
    @ResponseBody
    @GetMapping("/getAccountInfoPage")
    @ApiOperation(value = "用户信息分页(计费系统)")
    public AjaxMessage<Pagination<ClientUser>> getAccountInfoPage(
            @ApiParam(value = "页数,非必传，默认第一页", required = false, defaultValue = "1") @RequestParam(required = false, defaultValue = "1") int pageNum,
            @ApiParam(value = "条数，非必传，默认15条", required = false, defaultValue = "15") @RequestParam(required = false, defaultValue = "15") int pageSize) {

        Pagination<ClientUser> pageInfo = appletsService.getAccountInfoPage(pageNum, pageSize);
        return new AjaxMessage<>(ResultStatus.OK, pageInfo);
    }
    @ResponseBody
    @PostMapping("/setDefault")
    @ApiOperation(value = "设置默认(计费系统)")
    public AjaxMessage setDefault(
            @ApiParam(value = "id", required = true) @RequestParam(required = true) Integer id
    ) {
        appletsService.setDefault(id);
        return new AjaxMessage<>(ResultStatus.OK);
    }
    @PostMapping("bindingMobile")
    @ApiOperation(value = "绑定手机号码")
    public AjaxMessage bindingMobile(
            @ApiParam(value = "加密数据", required = true) @RequestParam(required = true) String encryptedData,
            @ApiParam(value = "加密算法的初始向量", required = true) @RequestParam(required = true) String iv,
            @ApiParam(value = "code", required = true) @RequestParam(required = true) String code,
            HttpServletRequest httpServletRequest
    ) {

        int result=appletsService.bindingMobile(encryptedData, iv, code);
        if(result==0){
            return new AjaxMessage<>(ResultStatus.OK);
        }else{
            return new AjaxMessage(ResultStatus.ERROR);
        }

    }
}
