package com.zoniot.ccrc.controller.applets;


import com.zoniot.ccrc.commom.model.AjaxMessage;
import com.zoniot.ccrc.commom.model.ResultStatus;
import com.zoniot.ccrc.entity.WarningRule;
import com.zoniot.ccrc.scheduled.WarningMessageJob;
import com.zoniot.ccrc.service.WarningRuleService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@Slf4j
@Controller
@ResponseBody
@RequestMapping("warningRule")
@Api( tags = "小程序预警规则")
public class WarningRuleController {

    @Autowired
    private WarningRuleService warningRuleService;
    @Autowired
    private WarningMessageJob warningMessageJob;


    @ResponseBody
    @GetMapping("/getList")
    @ApiOperation(value = "规则列表")
    public AjaxMessage<List<WarningRule>> getList(){

        List<WarningRule> pageInfo = warningRuleService.getRuleList();
        return new AjaxMessage<>(ResultStatus.OK, pageInfo);
    }

    @ResponseBody
    @PostMapping("/add")
    @ApiOperation(value = "添加")
    public AjaxMessage bindingAccount(
            @ApiParam(value = "预警类型 1：较上日用水量激增30% 2：连续无用水量超过7天", required = true) @RequestParam(required = true) Integer warningType
    ) {
        ;
        return new AjaxMessage<>(ResultStatus.OK,warningRuleService.addRule(warningType));
    }


    @ResponseBody
    @DeleteMapping("/del")
    @ApiOperation(value = "删除")
    public AjaxMessage del(
            @ApiParam(value = "id", required = true) @RequestParam(required = true) Integer id
    ){
        warningRuleService.delWaringRule(id);
        return new AjaxMessage<>(ResultStatus.OK);
    }
    @GetMapping("/startTheAlertImmediately")
    @ApiOperation(value = "立即启动预警")
    public void startTheAlertImmediately(){
        warningMessageJob.warningMessage();
    }
}
