package com.zoniot.ccrc.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.List;

@Data
@ApiModel("权限")
public class Permission implements Serializable {

    private static final long serialVersionUID = -2576516836375530733L;

    @ApiModelProperty(value = "id", position = 1)
    private Integer id;

    @ApiModelProperty(value = "父类id,最上层值为1", position = 2)
    private Integer parentId;

    @ApiModelProperty(value = "名称", position = 3)
    private String name;

    @ApiModelProperty(value = "权限", position = 4)
    private String permission;

    @ApiModelProperty(value = "图标", position = 5)
    private String icon;

    @ApiModelProperty(value = "路径", position = 6)
    private String path;

    @ApiModelProperty(value = "排序", position = 7)
    private Integer sort;

    @ApiModelProperty(value = "是否是菜单", position = 8)
    private Integer isMenu;

    @ApiModelProperty(value = "状态 0:禁用 1:正常", position = 9, hidden = true)
    private Integer status;

    @ApiModelProperty(value = "是否是超级管理员菜单", position = 10)
    private Integer isSuperAdminMenu;

    @ApiModelProperty(value = "是否是站点菜单", position = 11)
    private Integer isSiteMenu;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间", position = 50, hidden = true)
    private LocalDateTime createDate;

    @ApiModelProperty(value = "创建人", position = 51, hidden = true)
    private String createBy;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "更新时间", position = 52, hidden = true)
    private LocalDateTime updateDate;

    @ApiModelProperty(value = "更新人", position = 53, hidden = true)
    private String updateBy;

    @ApiModelProperty(value = "系统id", position = 100, hidden = true)
    private Integer sysId;

    @ApiModelProperty(value = "是否是计费菜单", position = 100)
    private Integer isBillingMenu;

    @ApiModelProperty(value = "子集", hidden = true)
    private List<Permission> children;

    @ApiModelProperty(value = "别名", position = 5)
    private String alias;

    @ApiModelProperty(value = "父节点id集合", position = 100)
    private List<Integer> collections;

}
