package com.zoniot.ccrc.service;


import com.zoniot.ccrc.entity.Permission;

import java.util.List;

public interface PermissionService {

    int insert(Permission permission);

    int insertSelective(Permission permission);

    int insertList(List<Permission> permissions);

    int update(Permission permission);

    List<Permission> getAllMenu();

    /**
     * 获取用户的菜单
     * @return
     */
    List<Permission> getMenuTreeByUserId(Integer userId);

    List<Permission> getPermissionByUserId(Integer userId, Integer siteId);

    List<Permission> getElementByUserId(Integer id);

    List<Permission> getAllPermission();

    List<Permission> getRolePermissionByRoleId(Integer roleId);

    void savePermission(Integer roleId, List<Integer> pids);

    /**
     * 添加权限
     * @param permission
     */
    void addPermission(Permission permission);

    /**
     * 编辑权限
     * @param permission
     */
    void editPermission(Permission permission);

    /**
     * 删除权限
     * @param id
     */
    void delPermission(Integer id);

    /**
     * 查看超级管理员权限
     * @return
     */
    List<Permission> getPermissionBySuperAdmin();

    List<Permission> getPermissionBySiteAdmin(Integer siteId);

    List<Permission> getPermissionBySiteAdminV2(Integer id, Integer type);

    List<Permission> getPermissionBySiteType(Integer type);

    List<Permission> getSitePermission(Integer siteId);
}
