package com.zoniot.ccrc.service;


import com.zoniot.ccrc.commom.model.Pagination;
import com.zoniot.ccrc.dto.DeleteUserDto;
import com.zoniot.ccrc.dto.UserDto;
import com.zoniot.ccrc.dto.UserRoleDto;
import com.zoniot.ccrc.entity.User;

import java.math.BigInteger;
import java.util.List;

public interface UserService {


    int insertSelective(User user);


    int update(User user);

    User findUserById(Integer id);


    /**
     * 添加用户
     */
    void addUser(String username, String name, String mobilePhone, Integer roleId);

    /**
     * 编辑用户
     */
    void editUser(Integer id, String name, String mobilePhone, Integer roleId);

    /**
     * 启用/禁用用户 更新状态
     * @param id
     */
    void updateStatus(Integer id);

    /**
     * 删除用户
     * @param id
     */
    void delectUser(Integer id);

    /**
     * 用户登录
     * @param username
     * @param password
     * @return
     */
    String login(String username, String password);

    String mobileLogin(String mobile, String password);

    String wechatLogin(User user);

    void logout();

    /**
     * 获取用户列表
     * @return
     * @param username
     * @param name
     * @param mobilePhone
     * @param organId
     * @param pageNum
     * @param pageSize
     */
    Pagination<UserRoleDto> getUserList(String username, String name, String mobilePhone, Integer organId, Integer roleId, Integer programId, int pageNum, int pageSize);

    /**
     * 批量删除用户
     * @param deleteUserDto
     */
    void batchDelectUser(DeleteUserDto deleteUserDto);

    /**
     * 修改用户密码
     * @param oldPassword
     * @param newPassword
     */
    void changePassword(String oldPassword, String newPassword);

    List<UserDto> unbindUser(Integer siteId);

    List<UserDto> deleteQuery(List<Integer> userIds);

    /**
     * @param openid
     * @return
     */
    User findUserByOpenid(String openid);

    List<UserDto> getAllUserList(Integer organId, String taskId);


    void changeSite(Integer siteId);


    void bindOpenId(String openId);

    User findUserByName(String name, BigInteger sitId);

    void addIntegrationUser(String username, String mobilePhone);

    void delectIntegrationUser(String mobilePhone);
}
